#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <algorithm>
#include <cmath>
#include <stack>
#include <functional>
#include <set>
#include <sstream>
#include <queue>
#include <string>
#include <cstring>
#include <map>
#include <iomanip>
#include <random>
#include <cassert>
using namespace std;

void go_gen(int T_case, int N, int L, int minA, int maxA, int rand_seed)
{
   stringstream ss;
   ss << T_case;
   string s;
   ss >> s;
   if (T_case < 10)
      s = "0" + s;
   s += ".in";
   const char *file_name = s.c_str();
   freopen(file_name, "w", stdout);
   cout << N << ' ' << L << endl;

   mt19937 gen(rand_seed);
   uniform_int_distribution<> dist(minA, maxA);
   for (int i = 0; i < N; i++)
      cout << dist(gen) << ' ';
}

int main()
{
   go_gen(7, 8, 5, 1, 5, 7548964);
   go_gen(8, 9, 50, 40, 50, 7548474);
   go_gen(9, 10, 1000, 1, 1000, 8569047);
   go_gen(10, 998, 2, 1, 5, 635908556);
   go_gen(11, 999, 13, 1, 5, 3908053);
   go_gen(12, 1000, 999, 1, 5, 20861593);
   go_gen(13, 9998, 17, 90, 100, 3606350);
   go_gen(14, 9999, 57, 900, 1000, 3045650);
   go_gen(15, 10000, 1000, 1, 1000, 5305369);
   go_gen(16, 10000, 1000, 1000, 1000, 657354);
}