{$APPTYPE CONSOLE}

var
  a, curA, bestA: array of Integer;
  N, L, bestT: Integer;
  used: array of Boolean;

  procedure Rec(p, leftT, rightT: Integer);
  var
    i: Integer;
  begin
    if p = N then begin
      if rightT < bestT then begin
        bestT := rightT;
        bestA := Copy(curA);
      end;
      exit;
    end;
    for i := 0 to High(a) do begin
      if used[i] then continue;
      used[i] := true;

      curA[p] := i;
      if rightT - a[i] >= leftT then
        Rec(p + 1, rightT - a[i], rightT + L)
      else
        Rec(p + 1, leftT, leftT + a[i] + L);
      used[i] := false;
    end;
  end;

var
  f: TextFile;
  i, j, m, t, leftT, rightT: Integer;
begin
  AssignFile(f, 'input.txt'); Reset(f);
  Read(f, N, L);
  SetLength(a, N);
  for i := 0 to High(a) do Read(f, a[i]);
  CloseFile(f);

  SetLength(used, N);
  for i := 0 to High(used) do used[i] := false;
  bestT := MaxInt;
  bestA := nil;
  curA := Copy(a);
  Rec(0, 0, 0);

  for i := 0 to High(a) do curA[i] := i;
  for i := 0 to High(a) - 1 do begin
    m := i;
    for j := i + 1 to High(a) do
      if a[curA[j]] < a[curA[m]] then m := j;
    if m <> i then begin
      t := curA[m];
      curA[m] := curA[i];
      curA[i] := t;
    end;
  end;

  leftT := 0;
  rightT := 0;
  for i := 0 to High(a) do begin
    Writeln(leftT, ':', rightT);
    t := a[curA[i]];
    if rightT - t >= leftT then
      leftT := rightT - t;
    rightT := leftT + t + L;
  end;
    Writeln(leftT, ':', rightT);
  AssignFile(f, 'output.txt'); Rewrite(f);
  Writeln(f, rightT);
  for i := 0 to High(a) do Write(f, a[curA[i]], ' ');
  Writeln(f);
  Writeln(f, bestT);
  for i := 0 to High(bestA) do Write(f, a[bestA[i]], ' ');
  CloseFile(f);
end.
